C***********************************************************************
C               E+ E- --> (2,3,4,5) PARTONS  (21-04-1989)
C***********************************************************************
C LITERATURE:
C   EXACT EXPRESSIONS FOR PROCESSES INVOLVING A VECTOR BOSON AND
C   UP TO FIVE PARTONS, BY BERENDS, GIELE & KUIJF.
C   TO BE PUBLISHED IN NUCLEAR PHYSICS B (IN PRINT).
C***********************************************************************
      PROGRAM EESHEL
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      PARAMETER(PI=3.141592653589793238D0)
      COMMON /BVEG1/ XL(10),XU(10),ACC,NDIM,NCALL,ITMX,NPRN
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      COMMON /CUTS/ ETAMAX,ETMIN,RCUT,YMIN,ICTYPE,ACOMIN,DELTA,EPS
      COMMON /EFFIC/ NIN,NOUT,D(3)
      EXTERNAL FXN
C
C PHYSICS PARAMETERS:
C   NUTF : NUMBER OF UP TYPE FLAVOURS
C   NDTF : NUMBER OF DOWN TYPE FLAVOURS
C   W    : CM ENERGY
C
      NJET=5
      NUTF=2
      NDTF=3
      NF=NUTF+NDTF
      W=50.D0
      RMZ=92.D0
      Q=RMZ
      QCDL=0.2D0
C
C VEGAS PARAMETERS
C NOTE: ONE DUMMY VARIABLE TO USE VEGAS!
C
      ITMX=1
      NCALL=10000
      NDIM=1
      DO 20 I=1,10
        XL(I)=0.D0
        XU(I)=1.D0
   20 CONTINUE
      ACC=-1.D0
      NPRN=1
C
C ICON DETERMINES WHICH INTERFERENCE TERMS TO USE
C ICON=0 ALL, ICON=1 GIVES GG, ICON=2 GIVES GZ, ICON=3 GIVES ZZ
C
      ICON=0
C
C ICTYPE DETERMINES WHICH TYPE OF CUTS TO USE
C ICTYPE=1:   P PBAR TYPE OF CUTS,   =2:   INVARIANT MASS CUT
C
      ICTYPE=2
      ETAMAX=10D0
      ETMIN=0.D0
      RCUT=2D0
      YMIN=0.01D0
C
C DEFINITION OF WEAK ANGLE
C
      SW2=0.23D0
C
C COUPLING CONSTANTS : GS, EM
C
      AS=ALPHAS(Q)
      GS=DSQRT(4.D0*PI*AS)
      AM=1.D0/(137D0)
      EM=DSQRT(4.D0*PI*AM)
C
C DETERMINE THE WIDTH OF THE Z, NOTE THAT WE USE THE ENERGY DEPENDENT
C WIDTH FOR THE Z:  i/(S-RMZ**2+i*S*RGZ/RMZ)
C
      SCW=2D0*DSQRT(SW2)*DSQRT(1D0-SW2)
      VE=(-0.5D0+2.D0*SW2)/SCW
      AE=-0.5D0/SCW
      VNU=0.5D0/SCW
      ANU=0.5D0/SCW
      VU=(0.5D0-4.D0*SW2/3.D0)/SCW
      AU=0.5D0/SCW
      VD=(-0.5D0+2.D0*SW2/3.D0)/SCW
      AD=-0.5D0/SCW
C
C CALCULATE THE WIDTH OF THE Z ( NO TOP QUARK! )
C
      GEE=   EM**2*(VE**2+AE**2)   *RMZ/12.D0/PI
      GNUNU= EM**2*(VNU**2+ANU**2) *RMZ/12.D0/PI
      GUU=   EM**2*(VU**2+AU**2)   *RMZ/12.D0/PI
      GDD=   EM**2*(VD**2+AD**2)   *RMZ/12.D0/PI
      RGZ=3.D0*(GEE+GNUNU) +3.D0*(1.D0+(AS/PI))*(2.D0*GUU+3.D0*GDD)
C
C EFFICIENCY OF INTEGRATION
C
      NIN=0
      NOUT=0
C
C D(3) ARE RELATIVE CONTRIBUTIONS FOR GG, GZ AND ZZ
C
      D(1)=0D0
      D(2)=0D0
      D(3)=0D0
C
C INIT HISTOGRAMS
C
      CALL HISTO(0,0,0D0,0.D0,25.D0,WT,1,' ',6,25)
C
C NO USE TO INITIALIZE THE GRID, ONE CALL TO VEGAS
C
      CALL VEGAS(FXN,AVGI,SD,CHI2A)
C
C OUTPUT RESULTS
C
      EFF=1.0D0*NIN/(NIN+NOUT)
      DTOT=D(1)+D(2)+D(3)
      DO 30 I=1,3
   30   D(I)=D(I)/DTOT
C
      WRITE(6,10)NJET,AVGI,SD,CHI2A
      WRITE(6,14)W
      IF (ICTYPE.EQ.1) WRITE(6,15)ETAMAX,ETMIN,RCUT
      IF (ICTYPE.EQ.2) WRITE(6,16)YMIN
      WRITE(6,17)D(1),D(2),D(3)
      WRITE(6,12)NIN,NOUT,EFF
      WRITE(6,18)ICON
      CALL HISTO(1,2,0D0,0D0,3D0,0D0,1,' ETA distribution ',6,10)
      CALL HISTO(2,2,0D0,0.D0,50.D0,0D0,1,' PT distribution ',6,25)
 
  10  FORMAT(//,' SIGMA(',I2,') = ',G16.7,'  +/-',G16.7,'  (',F7.3,')')
  12  FORMAT(/,' [IN,OUT,EFF]  :  ',2I6,F7.3)
  14  FORMAT(/,' [CM ENERGY]  :  ',F7.2)
  15  FORMAT(/,' [ETAMAX,ETMIN,RCUT]  :  ',3F7.2)
  16  FORMAT(/,' [YMIN]  :  ',1F7.2)
  17  FORMAT(/,' [GG,GZ,ZZ] : ',3F7.4)
  18  FORMAT(/,' [ICON]  :  ',1I1)
      STOP
      END
 
      FUNCTION FXN(X,WGT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(10)
      COMMON /BVEG1/XL(10),XU(10),ACC,NDIM,NCALL,ITMX,NPRN
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      COMMON /RESULT/ EEGG,EEGZ,EEZZ
      COMMON /EFFIC/ NIN,NOUT,D(3)
 
C GENERATE ONE EVENT
      CALL PHASE(X,WT)
C FINAL STATE CUTS : RETURNS ZERO IF EVENT FAILS
      CALL CUT(IDUMP)
      IF(IDUMP.EQ.0) THEN
          FXN=0.D0
          NOUT=NOUT+1
          RETURN
       ENDIF
C FLUX FACTOR
      FLUX=1D0/(2D0*W**2)
      CALL SFMEE(RINT)
C CONVERT TO NANOBARNS
      WT=WT*389385.73D0*FLUX
      FXN=WT*RINT
C GG, GZ, ZZ CONTRIBUTIONS
      D(1)=D(1)+EEGG*WT*WGT
      D(2)=D(2)+EEGZ*WT*WGT
      D(3)=D(3)+EEZZ*WT*WGT
      CALL BINO(FXN*WGT/DFLOAT(ITMX))
      NIN=NIN+1
      RETURN
      END
C
      SUBROUTINE PHASE(Y,WEIGHT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(PI=3.141592653589793238D0)
      DIMENSION Y(10),AM(100),PS(4,100)
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      COMMON /MOM/ PLAB(4,10)
      DATA AM/100*0D0/
 
C NOTE PLAB(*,1,2) ARE INCOMING (THE POSITRON-ELECTRON PAIR!)
      PLAB(1,1)=0.D0
      PLAB(2,1)=0.D0
      PLAB(3,1)=.5*W
      PLAB(4,1)=.5*W
      PLAB(1,2)=0.D0
      PLAB(2,2)=0.D0
      PLAB(3,2)=-.5*W
      PLAB(4,2)=.5*W
C GENERATE THE JETSMOMENTA IN THE CM FRAME
      CALL RAMBO(NJET,W,AM,PS,WTPS)
      DO 20 I=1,NJET
        DO 20 J=1,4
          PLAB(J,I+2)=PS(J,I)
  20  CONTINUE
      WEIGHT=WTPS*(2D0*PI)**(4.D0-3.D0*DFLOAT(NJET))
      RETURN
      END
C
      SUBROUTINE CUT(ICUT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION PT(5),ETA(5),DR(5,5)
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      COMMON /MOM/ PLAB(4,10)
      COMMON /CUTS/ ETAMAX,ETMIN,RCUT,YMIN,ICTYPE,ACOMIN,DELTA,EPS
      COMMON /BINVAR/ PT,ETA,DR,Y
 
C CALCULATE VARIOUS PROPERTIES OF THE EVENT.
      Y=1D0
      DO 10 I=1,NJET
        PT(I)=DSQRT(PLAB(1,I+2)**2+PLAB(2,I+2)**2)
        ETA(I)=.5*DLOG((PLAB(4,I+2)+PLAB(3,I+2))
     .                /(PLAB(4,I+2)-PLAB(3,I+2)))
          DO 10 J=I+1,NJET
            DR(I,J)=R(I+2,J+2)
            DR(J,I)=DR(I,J)
            YTEMP=(-PLAB(1,I+2)*PLAB(1,J+2)-PLAB(2,I+2)*PLAB(2,J+2)
     .             -PLAB(3,I+2)*PLAB(3,J+2)+PLAB(4,I+2)*PLAB(4,J+2))/
     .            (W**2)
            IF(YTEMP.LT.Y) Y=YTEMP
  10  CONTINUE
C
      ICUT=1
C ICTYPE = 1, JET LIKE CUT TYPE
      IF (ICTYPE.EQ.1) THEN
C JET TRANSVERSE MOMENTA AND RAPIDITIES
        DO 20 I=1,NJET
          IF(PT(I).LT.ETMIN) ICUT=0
          IF(DABS(ETA(I)).GT.ETAMAX) ICUT=0
C JET SEPARATION...
          DO 20 J=I+1,NJET
            IF(DR(I,J).LT.RCUT) ICUT=0
  20    CONTINUE
      END IF
C
C ICTYPE =2, APPLY THE USUAL E+ E- INVARIANT MASS CUT
      IF (ICTYPE.EQ.2) THEN
        IF (Y.LT.YMIN) ICUT=0
      END IF
      RETURN
      END
C
      SUBROUTINE SFMEE(EETOT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      COMMON /RESULT/ EEGG,EEGZ,EEZZ
C
      IF(NJET.EQ.2) CALL SFEE2J(EETOT)
      IF(NJET.EQ.3) CALL SFEE3J(EETOT)
      IF(NJET.EQ.4) CALL SFEE4J(EETOT)
      IF(NJET.EQ.5) CALL SFEE5J(EETOT)
C
      IF(ICON.EQ.1) EETOT=EEGG
      IF(ICON.EQ.2) EETOT=EEGZ
      IF(ICON.EQ.3) EETOT=EEZZ
C
      RETURN
      END
C
      FUNCTION R(I,J)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/MOM/PLAB(4,10)
      DELY=.5*DLOG((PLAB(4,I)+PLAB(3,I))*(PLAB(4,J)-PLAB(3,J))
     &     /((PLAB(4,J)+PLAB(3,J))*(PLAB(4,I)-PLAB(3,I))))
      Y= (PLAB(1,I)*PLAB(1,J)+PLAB(2,I)*PLAB(2,J))
     &      /DSQRT((PLAB(1,I)**2+PLAB(2,I)**2)*(PLAB(1,J)**2
     &      +PLAB(2,J)**2))
      IF(Y.LT.-1D0) Y=-1D0
      DELFI=DACOS(Y)
      R=DSQRT(DELY**2+DELFI**2)
      RETURN
      END
C
      FUNCTION ALPHAS(RQ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(PI=3.141592653589793238D0)
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      ALPHAS=6.*PI/((33.-2.*NF)*DLOG(RQ/QCDL))
      RETURN
      END
C
      SUBROUTINE BINO(WT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION PT(5),ETA(5),DR(5,5)
      COMMON /GENERA/ W,Q,QCDL,EM,GS,SW2,RMZ,RGZ,NJET,NF,NUTF,NDTF,ICON
      COMMON /BINVAR/ PT,ETA,DR,Y
C
      DO 10 I=1,NJET
        CALL HISTO(1,1,DABS(ETA(I)),0.D0,3.D0,WT,1,' ',6,10)
        CALL HISTO(2,1,PT(I),0.D0,50.D0,WT,1,' ',6,25)
   10 CONTINUE
C
      RETURN
      END

